<?php
if(!class_exists("Gc_Message_Box_Renderer")){
    class Gc_Message_Box_Renderer extends Gc_MessageBox_Abstract_Renderer{
        protected $options;

        public function __construct($namespace, $controller){
            parent::__construct($namespace,$controller);
    	}

    	public function render($gci){
			if (!$this->is_box_enabled()) {
				return '';
			}
            echo "<div class=\"gc_message_box\" id='gci_".$gci."' style='".$this->get_style()."'>".
            $this->render_inner_content().
            "</div>";
    	}
		
		public function is_box_enabled() {
			return ($this->get_option_value('box_enable') == "1");
		}

        protected function get_general_options(){
            return $this->options->filter_options_by_group("general");
        }

        protected function get_style_options(){
            return $this->options->filter_options_by_group("style");
        }


        protected function render_inner_content() {
            $align = $this->get_option_value('content_layout');
            $align_renderer = new Gc_Message_Box_Align_Renderer($align, $this);
            return $align_renderer->render();
        }
        
        protected function get_style() {
            $style = "";
            //Margins
            if ($this->controller->is_list()) {
                $style .= "margin-top: " . $this->get_option_value('margin_top_list') . "px; ";
                $style .= "margin-right: " . $this->get_option_value('margin_right_list') . "px; ";
                $style .= "margin-bottom: " . $this->get_option_value('margin_bottom_list') . "px; ";
                $style .= "margin-left: " . $this->get_option_value('margin_left_list') . "px; ";
            }
            if ($this->controller->is_page() or $this->controller->is_article()) {
                $style .= "margin-top: " . $this->get_option_value('margin_top_page') . "px; ";
                $style .= "margin-right: " . $this->get_option_value('margin_right_page') . "px; ";
                $style .= "margin-bottom: " . $this->get_option_value('margin_bottom_page') . "px; ";
                $style .= "margin-left: " . $this->get_option_value('margin_left_page') . "px; ";
            }
            //Padding
            $style .= "padding: 12px; ";
            return $style;
        }
        
        public function render_message() {
			if ($this->get_option('message_text')->is_formatting_enabled()) {
				$message_text = $this->add_html_formatting($this->get_option_value('message_text'));
			} else {
				$message_text = $this->get_option_value('message_text');
			}
            $message = "<span id=\"".$this->namespace."message\">".$message_text."</span>";
            return $message;
        }
        
        public function render_button($class = null) {
			if ($this->get_option('action_button_text')->is_formatting_enabled()) {
				$message = $this->add_html_formatting($this->get_option_value('action_button_text'));
			} else {
				$message = $this->get_option_value('action_button_text');
			}
            if (empty($message)) {
                return;
            }
            $content = "";
            if ($this->get_option('action_target')->is_checked()) {
                $content = "<a target=\"_blank\" ";
            } else {
                $content = "<a target=\"_top\" ";
            }
            $content .= "class=\"".$this->namespace.$class."\" href=".$this->get_option_value('action_url').">";
            $content .= "<span id=\"".$this->namespace."button\">";
            $content .= "<span id=\"".$this->namespace."buttontext\">".$message;
            $content .= "</span></span></a>";
            return $content;
        }
		
		protected function add_html_formatting($text) {
			$text = preg_replace('/&lt;b&gt;([\s\S]*)&lt;\/b&gt;/i', '<b>${1}</b>', $text);
			$text = preg_replace('/&lt;s&gt;([\s\S]*)&lt;\/s&gt;/i', '<s>${1}</s>', $text);
			$text = preg_replace('/&lt;i&gt;([\s\S]*)&lt;\/i&gt;/i', '<i>${1}</i>', $text);
			$text = preg_replace('/&lt;u&gt;([\s\S]*)&lt;\/u&gt;/i', '<u>${1}</u>', $text);
			return $text;
		}
        
    }
}